# DE2-115-FPGA-Pong

Pong game on Altera FPGA as exercise in Hardware-/Software-Codesign

## Datenflussdiagramm
![](images/data_graph.png)

## Programmablaufplan des C Programms
Below images show flowcharts for all featured software functions.
Fist chart feature the main game function. Subfunctions are described below.
See:    
- draw
- reset_positons
- reset_screen

### Main function Flowchart
![](images/game_function_PAP.png)

---

### Subfunctions  Flowcharts
Flowchart of draw function.
Function output the virtual screen to the output pins to be processed by VHDL

![](images/draw.png)

---

Flowchart of reset_position function.
Function to reset positions of both paddles and ball to default. 
Default positions and values can be adjusted in this function

![](images/reset_positions.png)

---

Flowchart of reset_screen function.
Function to reset all pixels of the virtual screen to 0.

![](images/reset_screen.png)